



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>学习Sass 的基本语法规则[Sass和compass学习笔记]</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">学习Sass 的基本语法规则[Sass和compass学习笔记]</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 06:03:03 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>自从发现可编程的css语法 Sass和基于Sass的css库compass</p>
<p>一个给我的感觉像c# 另外一个给我的感觉像.NET Framework，一切都为了提升开发效率和降低开发大型web的门槛。</p>
<p>当web开发趋势迈进WebApi+Js 时代，compass和Sass 会不会成为web开发的标配？这个得实际开发检验下.</p>
<h1>预处理</h1>
<p>当web站点变的越来越复杂。</p>
<p>先是html 复杂了----》动态编程语言解决方案</p>
<p>js复杂了---》jq和dojo 等解决方案</p>
<p>css现在也变的复杂了，但是css本身没有编程的功能，所以面向css预处理的中间件出现了，想compass和Sass这种想编写程序一样编写css，然后通过预处理，处理为浏览器可以解析的css，降低了构建更加强大的web站点复杂度。</p>
<h1>变量</h1>
<p>变量和js、c# 里面的变量差不多，都是用来存储东西了，我这样的菜鸟写css，最头疼一次修改好多高度，颜色等等，有了变量，即使是最笨的方法，编写css也比以前快多了了</p>
<p>在 sass 里面变量的标识符是$,话说和jq是一样的标识符呢</p>
<p>例如</p>
<pre class="prettyprint linenums">$font-stack:    Helvetica, sans-serif;<br />
$primary-color: #333;

body {<br />
  font: 100% $font-stack;<br />
  color: $primary-color;<br />
}</pre>
<p>这样编写的sass版的css在经过compass预处理后是可以正常解析的css，而且每一行还会有行号，用于对照比较，刚开始非常担心处理前和处理后如何联系到一起，排查BUG，后来发现有行号，so 方便</p>
<pre class="prettyprint linenums">body {<br />
  font: 100% Helvetica, sans-serif;<br />
  color: #333;<br />
}</pre>
<h1>嵌套和作用域</h1>
<p>以前写css，最蛋疼的就是 css默认规则是一行一行的，BUT css超过一屏幕，我就搞不清楚这些css 是怎么个关系。。。</p>
<p>现在好了 有{} 嵌套和作用域，像写程序一样写css</p>
<p>纳尼，作用域？上面都有了变量跟定得有作用域，不知道作用域的，百度下</p>
<p>sass 的嵌套 和预处理后的css 是按照html对css的继承和处理规则来的，看着比以前舒服多了</p>
<pre class="prettyprint linenums">nav {<br />
  ul {<br />
    margin: 0;<br />
    padding: 0;<br />
    list-style: none;<br />
  }

  li { display: inline-block; }

  a {<br />
    display: block;<br />
    padding: 6px 12px;<br />
    text-decoration: none;<br />
  }<br />
}</pre>
<p>预处理后 是这样的</p>
<pre class="prettyprint linenums">nav ul {<br />
  margin: 0;<br />
  padding: 0;<br />
  list-style: none;<br />
}

nav li {<br />
  display: inline-block;<br />
}

nav a {<br />
  display: block;<br />
  padding: 6px 12px;<br />
  text-decoration: none;<br />
}</pre>
<p>对于作用域，官方的demo 没有解释，这个是在书里面看到的</p>
<p>例如</p>
<pre class="prettyprint linenums">div{<br />
$font-stack:    Helvetica, sans-serif;<br />
$primary-color: #333;<br />
}

li{<br />
$font-stack:    Helvetica, sans-serif;<br />
$primary-color: #333;<br />
}</pre>
<p>在不同 {} 作用域内的变量互不影响</p>
<h1>模块</h1>
<p>看到这个单词 Partials,真的是喜极而泣啊,以前随便打开一个css文件都是1k行以上,本菜鸟在里面看代码,就好像在迷宫里面迷路一样,</p>
<p>sass的模块化是将需要模块化的css放在一个以下划线开始的单独的文件里面例如_partial.scss,使用这个模块的时候用<code>@import导入即可 </code></p>
<p><code>不支持模块化css的css框架都是耍流氓!</code></p>
<p><code>&#160;</code></p>
<p><strong></strong></p>
<h1>Import 导入模块</h1>
<p>在css中使用一个Import 便会像服务器端发起一个请求,在sass中使用Import,compass 可以导入一个模块,而且会合并这个导入的文件.</p>
<p>例如, 重置浏览器默认样式的模块</p>
<pre class="prettyprint linenums">// _reset.scss

html,<br />
body,<br />
ul,<br />
ol {<br />
   margin: 0;<br />
  padding: 0;<br />
}</pre>
<p>导入是这样导入的</p>
<pre class="prettyprint linenums">/* base.scss */

@import 'reset';

body {<br />
  font-size: 100% Helvetica, sans-serif;<br />
  background-color: #efefef;<br />
}</pre>
<p>生成的css 是浏览器可以解析的,而且带行号,方便对比</p>
<pre class="prettyprint linenums">html, body, ul, ol {<br />
  margin: 0;<br />
  padding: 0;<br />
}

body {<br />
  background-color: #efefef;<br />
  font-size: 100% Helvetica, sans-serif;<br />
}</pre>
<h1>sass 中的函数方法--Mixins</h1>
<p>函数 有函数名 参数 可选选参数,返回值等</p>
<p>在sass中 这些统统都有!具体我还在看书,这是官方的demo,足以发现mixins 是挺好用的</p>
<p>定义一个方法</p>
<pre class="prettyprint linenums">@mixin border-radius($radius) {<br />
  -webkit-border-radius: $radius;<br />
     -moz-border-radius: $radius;<br />
      -ms-border-radius: $radius;<br />
          border-radius: $radius;<br />
}</pre>
<p>使用一个方法</p>
<pre class="prettyprint linenums">.box { @include border-radius(10px); }</pre>
<p>可以发现用@mixin开头 后跟方法 名称 括号内为参数,{}中间为返回内容,</p>
<p>使用@include 后跟方法名和括号，便可以调用这个方法</p>
<p>compass预处理后 生成的css如下</p>
<pre class="prettyprint linenums">.box {<br />
  -webkit-border-radius: 10px;<br />
  -moz-border-radius: 10px;<br />
  -ms-border-radius: 10px;<br />
  border-radius: 10px;<br />
}</pre>
<h1>继承</h1>
<p>此继承为sass组织代码的继承规则，非html解析和呈现css时候的继承规则，不要搞混了。。。，虽然生成的代码符合css继承规则。。。。。。</p>
<p>继承 使用的关键字是@extend，使用很简单，来看一个官方的demo</p>
<pre class="prettyprint linenums">.message {<br />
  border: 1px solid #ccc;<br />
  padding: 10px;<br />
  color: #333;<br />
}

.success {<br />
  @extend .message;<br />
  border-color: green;<br />
}

.error {<br />
  @extend .message;<br />
  border-color: red;<br />
}

.warning {<br />
  @extend .message;<br />
  border-color: yellow;<br />
}</pre>
<p>预处理后生成的代码</p>
<pre class="prettyprint linenums">.message, .success, .error, .warning {<br />
  border: 1px solid #cccccc;<br />
  padding: 10px;<br />
  color: #333;<br />
}

.success {<br />
  border-color: green;<br />
}

.error {<br />
  border-color: red;<br />
}

.warning {<br />
  border-color: yellow;<br />
}</pre>
<h1>操作符</h1>
<p>sass 支持+、-、*、/、% 加减乘除和求余，是在是太劲爆了，这样在写宽度和高等等地方有更加方便了</p>
<p>看看官方的demo</p>
<pre class="prettyprint linenums">.container { width: 100%; }

article[role=&quot;main&quot;] {<br />
  float: left;<br />
  width: 600px / 960px * 100%;<br />
}

aside[role=&quot;complimentary&quot;] {<br />
  float: right;<br />
  width: 300px / 960px * 100%;<br />
}</pre>
<p>预处理后的代码</p>
<pre class="prettyprint linenums">.container {<br />
  width: 100%;<br />
}

article[role=&quot;main&quot;] {<br />
  float: left;<br />
  width: 62.5%;<br />
}

aside[role=&quot;complimentary&quot;] {<br />
  float: right;<br />
  width: 31.25%;<br />
}</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qydyedq.html">每日Scrum站会实践推荐</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q22lovq.html">基于Lattice&lowbar;CPLD&sol;FPGA Diamond 开发流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy6nnx8.html">用Razor做静态页面生成器</a>
		</li>
						<li><a href="https://www.batexi.com/a/495km009.html">cookie 二：</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7klr19.html">ACdrea  1217---Cracking&amp;&num;39&semi; RSA（高斯消元）</a>
		</li>
						<li><a href="https://www.batexi.com/a/390wg3jq.html">Eclipse中添加Android系统jar包</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxndeoj8.html">更改AD查询LDAP条目的1000限制</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0m31eq.html">Asp&period;net mvc与PHP的Session共享的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k12mg79.html">T-SQL 数据库笔试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnjkvv8.html">Oracle ROWNUM用法和分页查询总结（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvpy4oq.html">一次 php nusoap 调试过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo4x2xq.html">对RabbitMQ&period;Client进行一下小小的包装，绝对实用方便</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjwpjg8.html">mysql常用的hint</a>
		</li>
						<li><a href="https://www.batexi.com/a/950znxz8.html">201521123032 《Java程序设计》第3周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mlvro8.html">Vivado常见问题集锦</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y4dor8.html">HTML5仿微信聊天界面、微信朋友圈实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jkp63q.html">2017-9-11-Linux开机启动脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj7ov39.html">基于session做的权限控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o6ede8.html">火狐的3d视图插件Tilt 3D</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjyey39.html">jquery写tab切换&comma;三行代码搞定</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/xq44zv5q.html">20145204&amp;amp&semi;20145212实验二报告</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qndn5j8.html">&lbrack;NHibernate&rsqb;增删改操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4444jq.html">PHP cookie</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlook1q.html">c标签遍历List&amp;lt&semi;Map&amp;lt&semi;String&comma; Object&amp;gt&semi;&amp;gt&semi; 数据格式</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pmmvd9.html">tyvj1097 mm不哭</a>
			</li>
						<li><a href="https://www.batexi.com/a/49g34m4q.html">JavaScript - 初识</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jenzw8.html">SQLite的时候判断语句是否纯在：出现RuntimeException</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zvrw19.html">PHP同时上传&OpenCurlyDoubleQuote;多个&rdquo;文件示例，并格式化&dollar;&lowbar;FILES数组信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxle2jq.html">Linux 执行文件查找命令 which 详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd5z0v9.html">JS学习：第一周&mdash;&mdash;NO&period;1预解释</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
